(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

(* :Title: EDH, Estudio de Datos Homol\[OAcute]gico*)

(* :Author: L.J. Hern\[AAcute]ndez ( Universidad de La Rioja), 
  F.J. D\[IAcute]az D\[IAcute]az
	   (Universidad de La Laguna),
  Universidad de La Rioja,
  Departamento de Matem\[AAcute]ticas y Computaci\[OAcute]n,Edificio VIVES,
  C/Luis de Ulloa s/n,26004 Logro\[NTilde]o,Espa\[NTilde]a
      
      Tel:[34] 941 299468
      
      Fax:[34] 941 299460
      
      Email (Correo Electr\[OAcute]nico):
        luis-javier.hernandez@dmc.unirioja.es
      
      P\[AAcute]gina web:http://www.unirioja.es/dptos/dmc/luhernan/
  
  *)
(* Paquete incluye las funciones del paquete:  ElementaryDecompositions, 
  por Frank Zizza, University of Arizona South Department of Mathematics. 
        http://www.willamette.edu/~zizza/
      zizza@u.arizona.edu
  *)

(* :Summary:
         Decomposes matrices with entries in a Euclidean ring as a product of \
elementary matrices, 
  permutation matrices and a diagonal matrix.  
      Allowed Euclidean rings are the integers, the Gaussian integers, 
  and the polynomials in one variable over the fields of rational numbers, 
  real numbers or complex numbers. 
  *)

(* Agradecimientos: 
    Esta es la primera version de una familia de paquetes realizados para la \
aplicaci\[OAcute]n Mathematica por L.J.Hern\[AAcute]ndez y F.D\[IAcute]az con \
el objetivo de realizar estudios topol\[OAcute]gicos y geom\[EAcute]tricos de \
conjuntos de datos cualesquiera.Actualmente estamos realizando una segunda \
versi\[OAcute]n con los mismos objetivos pero con una nueva estructuraci\
\[OAcute]n con m\[AAcute]s posibilidades y con algoritmos m\[AAcute]s \
eficientes.Agradecemos la ayuda y orientaciones de J.F.Sanjuan sobre el uso \
de la aplicaci\[OAcute]n Mathematica y algunos trucos para la optimizaci\
\[OAcute]n de algor\[IAcute]tmos.Agracedemos
      tambi\[EAcute]n a Frank Zizza  su magnifico paquete \
ElementaryDecomposition,
  que entre otras funciones tiene algunas para calcular factores \
invariantes.Tambi\[EAcute]n a Manuel Castejon sus sugerentes comentarios que \
fueron los que nos motivaron a abordar este proyecto.*)

(* :Context: EDH` *)

(* :Package Version: 2003 *)

(* :Copyright: Copyright 2003 *)



(* :Keywords: 
       Complejo c\[UAcute]bico, funci\[OAcute]n desidad, homolog\[IAcute]a, 
  m\[UAcute]meros de Betti, 
  coeficientes de torsi\[OAcute]n, conjuntos de datos
  *)

BeginPackage["EDH`"]
  
  
  ComplejoCubico::usage=
      "ComplejoCubico[date, size] es una funci\[OAcute]n que tiene como \
entrada un par consistente en una lista de n-uplas de numeros reales (date), \
y una n-upla de numeros naturales (size). En adelante usaremos siempre n para \
representar la dimension de los datos. Obtiene una lista de n-uplas de \
numeros enteros, que representan los vertices de los n-cuboides con tama\
\[NTilde]o dado por size, caras paralelas a los hiperplanos del espacio \
n-dimensional y que contienen datos. Ademas estos cuboides se interpretaran, \
a la hora de ver si un dato esta o no en ellos, como cerrados en las caras \
que inciden con el vertice que los representa, y abiertos en el resto de las \
caras.";
  
  CocicloDensidad::usage=
      "CocicloDensidad[date, size] tiene la misma entrada que ComplejoCubico. \
Obtiene la misma lista que ComplejoCubico, a\[NTilde]adiendo una segunda \
componente a cada vertice de n-cuboide, que representa el numero de datos que \
cae en ese cuboide. Esta nueva componente es lo que se llamara en adelante \
densidad.";
  
  FuncionDensidad::usage=
      "FuncionDensidad[date, size] tiene la misma entrada que ComplejoCubico. \
Obtiene la misma lista que ComplejoCubico, a\[NTilde]adiendo una segunda \
componente a cada cubo, que representa el numero de datos que cae en ese \
cubo. Esta nueva componente es lo que se llamara en adelante densidad.";
  
  CocicloColor::usage=
      "CocicloColor[cd] tiene como entrada un cociclo densidad y obtiene una \
lista parecida a la cd, pero sustituyendo la densidad de cada cubo por un \
numero racional proporcional a las mismas, mayor que cero y menor o igual que \
uno. Este numero es el que elegira un color, mas oscuro cuanto mayor sea la \
densidad, a la hora de dibujar el complejo cubico.";
  
  Pinta2D::usage=
      "Pinta2D[cd] solo es utilizable si la dimension de los datos es 2. \
Tiene como entrada un cociclo densidad cd. Obtiene un dibujo bidimensional de \
los rectangulos de tama\[NTilde]o dado por size que contienen datos. El color \
de estos rectangulos sera mas oscuro cuanto mayor sea la densidad.";
  
  Pinta3D::usage=
      "Pinta3D[cd] solo es utilizable si la dimension de los datos es 3. \
Tiene como entrada un cociclo densidad cd .Obtiene un dibujo tridimensional \
de los 3-cubos que contienen datos. El color de estos 3-cubos ser\[AAcute] \
mas oscuro cuanto mayor sea la densidad.";
  
  PintaDensidad2D::usage=
      "PintaDensidad2D[cd] solo es utilizable si la dimension de los datos es \
2. Tiene como entrada un cociclo densidad cd.Obtiene un dibujo en el cual se \
a\[NTilde]ade una dimension al obtenido por NuevoPinta2D, mediante la \
asignacion a cada rectangulo de una altura proporcional a su densidad.";
  
  
  PintaPseudo2D::usage=
      "PintaPseudo2D[listacd] solo es utilizable si la dimension de los datos \
es 2. Tiene como entrada una lista de cociclos densidad listacd . Obtiene un \
dibujo en el cual cada Pseudocomponente aparece de un color las zonas de mas \
intensidad tienen mayor densidad.";
  
  etiquetas::usage=
      "Tiene como entrada una etiqueta, es decir, una n-upla formada por \
ceros y unos que representa las direcciones en las cuales vive un r-cubo. Por \
tanto, un par formado por un vertice del espacio n-dimensional y una etiqueta \
representa un r-cubo, con r la suma de los unos de la etiqueta. Obtiene una \
lista de todas las etiquetas que surgen suprimiendo una direccion en la \
etiqueta de entrada.";
  
  bajadimen::usage=
      "Tiene como entrada un r-cubo, representado por el par formado por un \
vertice del espacio n-dimensional y una etiqueta. Obtiene la lista de las \
caras de ese r-cubo, representadas por pares en el sentido de la entrada.";
  
  bajadimension::usage=
      "Tiene como entrada una lista de r-cubos, representados por el par \
formado por un vertice del espacio n-dimensional y una etiqueta. Obtiene la \
lista de las caras de esos r-cubos, representadas por pares en el sentido de \
la entrada.";
  
  etiquetassigno::usage=
      "Tiene como entrada una etiqueta. Obtiene la lista de todas las \
etiquetas que surgen suprimiendo una direccion en la de entrada, pero a\
\[NTilde]adiendo a cada una de las etiquetas de la lista saliente una segunda \
componente que indica su incidencia con la etiqueta de entrada.";
  
  borde::usage=
      "Tiene como entrada un r-cubo, representado por el par formado por un \
vertice del espacio n-dimensional y una etiqueta. Obtiene la lista de las \
caras de ese r-cubo, especificando la incidencia. En concreto proporciona una \
lista de triples formados por un vertice del espacio n-dimensional, una \
etiqueta y la incidencia con el r-cubo de entrada.";
  
  coefuno::usage=
      "Tiene como entrada el borde de un r-cubo, tal como se ha obtenido \
usando el comando borde anterior. Selecciona los (r-1)-cubos de ese borde que \
tienen incidencia 1, y los proporciona como una lista de pares, cada uno de \
ellos formado por un vertice del espacio n-dimensional y una etiqueta.";
  
  coefmenosuno::usage=
      "Tiene como entrada el borde de un r-cubo, tal como se ha obtenido \
usando el comando borde anterior.Selecciona los (r-1)-cubos de ese borde que \
tienen incidencia -1, y los proporciona como una lista de pares, cada uno de \
ellos formado por un vertice del espacio n-dimensional y una etiqueta";
  
  CuboIncidencia::usage="Funci\[OAcute]n auxiliar";
  
  PrimeraIncidencia::usage=
      "Tiene como entrada un complejo cubico,tal como se obtiene usando el \
comando ComplejoCubico. Obtiene el par que descibimos a continuacion: La \
primera componente es un par formado por la lista de los n-cubos y la lista \
de los (n-1)-cubos. La segunda componente es un conjunto cuyo unico elemento \
es la matriz de incidencia de los n-cubos con los (n-1)-cubos. Hay que \
puntualizar que los cubos son proporcionados, en la salida, en formato \
reducido, en el sentido ya indicado en el comando CubosIncidencias \
anterior.";
  
  
  CubosIncidencias::usage=
      "Tiene como entrada un complejo cubico, tal como se obtiene usando el \
comando ComplejoCubico. Obtiene el par que descibimos a continuacion: La \
primera componente es una lista con n+1 componentes, que son las sucesivas \
listas de cubos (empezando por la lista de los n-cubos y concluyendo por la \
lista de los vertices). La segunda componente es una lista con n componentes, \
que son las sucesivas matrices de incidencia (empezando por la incidencia de \
los n-cubos con los (n-1)-cubos y concluyendo por la incidencia de las \
aristas con los vertices). Hay que puntualizar que los cubos son \
proporcionados, en la salida, en formato reducido, es decir, en forma de \
(n+1)-uplas cuyas primeras n componentes se corresponden con las coordenadas \
de un vertice del espacio n-dimensional, y la (n+1)-componente es un numero \
entero no negativo que, expresado en base 2 y con longitud n, da las \
componentes de una etiqueta.";
  
  PseudoComponentes::usage=
      "Tiene como entrada un complejo cubico, tal como se obtiene usando el \
comando ComplejoCubico. Obtiene una lista cuyos elementos son las \
pseudocomponentes del complejo cubico de entrada. Estas pseudocomponentes \
vienen expresadas como conjuntos de n-cubos, cada uno de los cuales es \
representado unicamente por el vertice del espacio n-dimensional que lo \
caracteriza.";
  
  ListaDual::usage=
      "Funci\[OAcute]n auxiliar, de momento no recuerdo para que sirve. ";
  
  
  DimDual::usage=
      "Tiene como entrada un complejo cubico, tal como se obtiene usando el \
comando ComplejoCubico. Obtiene la dimension del complejo cubico dual que se \
obtiene con el comando Dual";
  
  Dual::usage=
      "Tiene como entrada un complejo cubico, tal como se obtiene usando el \
comando ComplejoCubico. Obtiene el complejo cubico dual, y lo expresa \
mediante una lista con n+1 componentes, que son
      las sucesivas listas de cubos (empezando por la lista de los n-cubos y \
concluyendo por la lista de los vertices). Los cubos son expresados como \
pares formados por un vertice del espacio n-dimensional y una etiqueta. Hay \
que remarcar que el complejo cubico dual que se obtiene no es necesariamente \
puro, es decir, no todos los cubos tienen que ser cara de uno de dimension \
maxima. Adem\[AAcute]s, es posible que la dimension del complejo dual sea \
inferior que la del complejo original, y en ese caso los conjuntos de cubos \
de dimensiones superiores a la dimension del dual son vacios.";
  
  
  CubosInDual::usage=
      "Tiene como entrada un complejo cubico, tal como se obtiene usando el \
comando ComplejoCubico. Obtiene el par que descibimos a continuacion: La \
primera componente es una lista con r+1 componentes, donde r es la dimension \
del complejo dual al dado, que son las sucesivas listas de cubos del complejo \
dual(empezando por la lista de los r-cubos y concluyendo por la lista de los \
vertices). La segunda componente es una lista con r componentes,que son las \
sucesivas matrices de incidencia (empezando por la incidencia de los r-cubos \
con los (r-1)-cubos y concluyendo por la incidencia de las aristas con los \
vertices).Hay que puntualizar que los cubos son proporcionados,en la \
salida,en formato reducido,es decir,en forma de (n+1)-uplas cuyas primeras n \
componentes se corresponden con las coordenadas de un vertice del espacio \
n-dimensional, y la (n+1)-componente es un numero entero no negativo que, \
expresado en base 2 y con  longitud n, da las componentes de una etiqueta.";
  
  
  PintaDual2D::usage=
      "Tiene como entrada un complejo cubico de dimension 2 (solo es valido \
para ese caso) tal como se obtiene usando el comando ComplejoCubico. Obtiene \
un dibujo bidimensional del dual del complejo cubico dado.";
  
  esquinas::usage="Funci\[OAcute]n auxiliar ";
  
  PintaDual3D::usage=
      "Tiene como entrada un complejo cubico de dimension 3 (solo es valido \
para ese caso) tal como se obtiene usando el comando ComplejoCubico. Obtiene \
un dibujo tridimensional del dual del complejo cubico dado.";
  
  Homologia::usage=
      "Homologia[ci], tiene como entrada una un cubosinciencia y como salida \
la homolog\[IAcute]a";
  
  ElementaryDecomposition::usage = 
    "ElementaryDecomposition[M] yields the factorization of the matrix M into \
elementary matrices, permutation matrices and a diagonal matrix.  The matrix \
M must have entries  in the ring of integers, or the ring of Gaussian \
integers. The result is a list {{e[i, j, a], p[i, j] ...}, {{{d[1],0,..}, {0, \
d[2], 0, ..}}}, {e[i, j, a], p[i, j] ...}}.  e[i, j, x] is the identity \
matrix except in position (i, j) where is has the value x. p[i, j] is the \
identity matrix with the i-th and j-th columns interchanged. The middle term \
in the result is a diagonal matrix {{d[1],0,..}, {0, d[2], 0, ..}}. The \
orginal matrix M is the product of all the matrices in the list in the order \
in which they are printed.
    \n \nElementaryDecomposition[M, t] yields the factorization for matrices \
with entries in the ring of polynomials in one variable t over a field.  The \
field is determined by the coefficients of the polynomials in the input \
matrix.
    \n \nElementaryDecomposition[M, Padded -> True] yields the same \
factorization as ElementaryDecomposition[M] with the elementary matrices and \
permutation matrices expanded as usual Mathematica matrices."
  
  NormalDecomposition::usage = 
    "NormalDecomposition[M] yields a factorization of the r x s matrix M into \
{P, D, Q} where P is r x r and invertable, D is r x s and diagonal and Q is s \
x s and invertable.  The original matrix M equals P . D . Q.  The entries of \
M must all be integers or Gaussian integers.  NormalDecomposition[M, t] works \
polynomials in a single variable over a field."
  
  InvariantFactors::usage = 
    "InvariantFactors[M] gives the diagonal elements of the normal form of \
the matrix M under the equivalence relation A ~ B iff A == P . B . Q where P \
and Q are invertable matrices.  The entries of M must all be integers or \
Gaussian integers.InvariantFactors[M, t] works for polynomials in a single \
variable over a field.  It is a standard theorem that all such matrices have \
a diagonal normal form.  The result is a list of elements {d[1], d[2], ... , \
d[k], 0, .. 0} of the appropriate ring with the divisibility condition d[i] | \
d[j] for all 1 <= i <= j <= k."
  
  ElementaryMatrix::usage = 
    "ElementaryMatrix[i, j, x, n] is a short form for n x n matrix which \
equals the identity matrix except in position (i, j) where is has the value \
x. In formatted output, the dimension n is suppressed and i and j are \
subscripted."
  
  PermutationMatrix::usage = 
    "PermutationMatrix[i, j, n] is a short form for n x n matrix that equals \
the identity matrix with the i-th and j-th columns interchanged. In formatted \
output, the dimension n is suppressed and i and j are subscripted."
  
  Pad::usage = 
    "Pad[elementary or permutation matrix] expands ElementaryMatrix[i, j, x, \
n] and PermutationMatrix[i, j, n] as actual matrices, i.e. a list of lists."
  
  Padded::usage = 
    "Padded is an option for ElementaryDecomposition which specfies whether \
the elementary matrices and the permutation matrices in the factorization \
should be given in compressed form as e[i,j,a] and p[i,j] or as actual \
matrices.  Padded -> True gives the actual matrices.  The default is Padded -> \
False."
  
  CheckIt::usage = 
    "CheckIt[factorization] multiplies the list of matrices obtained from \
ElementaryDecomposition."
  
  HoComCaComCu::usage=
      "HoComCaComCu[datos,size],  tiene como entrada los datos y el tamo\
\[NTilde]o del microcubo. La salida es la homolog\[IAcute]a del complejo c\
\[UAcute]bico que aproxima los datos";
  
  HoComCaDualComCu::usage=
      "HoComCaDualComCu[datos,size],  tiene como entrada los datos y el tamo\
\[NTilde]o del microcubo. La salida es la homolog\[IAcute]a del dual del \
complejo c\[UAcute]bico que aproxima los datos";
  
  HoComCaDualPseudoComCu::usage=
      "HoComCaDualPseudoComCu[datos,size],  tiene como entrada los datos y el \
tama\[NTilde]o del microcubo. La salida son las homolog\[IAcute]as de los \
duales de las pseudocomponentes del complejo c\[UAcute]bico que aproxima los \
datos";
  
  HoComCaDualPseudoComCu2D::usage=
      "HoComCaDualPseudoComCu2D[datos,size],  tiene como entrada los datos y \
el tama\[NTilde]o del microcubo. La salida pinta las pseudocomponentes \
coloreadas y luego salen las homolog\[IAcute]as de los duales de las \
pseudocomponentes del complejo c\[UAcute]bico que aproxima los datos";
  
  
  
  
  (*Options*)
  
  Options[ElementaryDecomposition] = {Padded -> False};
  
  
  (*Messages*)
  
  ElementaryDecomposition::notint = 
    "Matrix does not have entries in the integers or the Gaussian integers. \
For polynomial entries, append the variable as in ElementaryDecomposition[M, \
t]."
  
  ElementaryDecomposition::notpoly = 
    "Matrix does not have entries in the ring of polynomials in one \
variable."
  
  
  
  
  
  
  
  
  
  
  
  Begin["`Private`"]
  
  ComplejoCubico[data_List,size_List]:=
      Union[Sort[IntegerPart[Map[# size&,data]]]];
  
  CocicloDensidad[data_List,size_List]:=Module[{ccr,cc},
        ComplejoCubicoRepetido[da_List,si_List]:=
          Sort[IntegerPart[Map[# si&,da]]];
        ccr=ComplejoCubicoRepetido[data,size];
        cc=Union[ccr];
        densidad[cubo_]:={cubo,Count[ccr,cubo]};
        Map[densidad,cc]];
  
  
  
  FuncionDensidad[data_List,size_List]:=Module[{ccr,cc,si},
        si=size;
        ParaUnDato[da_List]:={IntegerPart[si*da],
            1-(Map[DiscreteDelta,FractionalPart[si*da]])};
        ccr=Sort[Map[ParaUnDato,data]];
        cc=Union[ccr];
        densidad[cubo_]:={cubo,Count[ccr,cubo]};
        {Map[densidad,cc],si}];
  
  CocicloColor[cd_]:=Module[{cd2,mad},
        cd2=Table[cd[[i]][[2]],{i,1,(Length[cd])}];
        mad=Max[cd2];
        Table[{cd[[i]][[1]],(4/10)(1-(cd2[[i]]/mad))+(cd2[[i]]/mad)},{i,
            1,(Length[cd])}]];
  
  Pinta2D[cd_]:=Module[{ccolor,tcubos},
        TablaCubos2D[colores_List]:=
          Table[{Hue[1,colores[[i]][[2]],1],
              Rectangle[colores[[i]][[1]],colores[[i]][[1]]+{1,1}]},{i,
              1,(Length[colores])}];
        ccolor=CocicloColor[cd];
        tcubos=TablaCubos2D[ccolor];
        Show[Graphics[tcubos]]];
  
  
  
  PintaPseudo2D[listacd_]:=Module[{l,le,casihue,casipintado, yacasipintado},
      Prepinta[cd_]:=Module[{cd1,cd2,mad,precd},
          cd1=Map[First,cd];
          cd2=Map[Last,cd];
          mad=Max[cd2];
          inten[j_]:=(4/10)(1-(cd2[[j]]/mad))+(cd2[[j]]/mad);
          
          Table[{inten[j],Rectangle[cd1[[j]],cd1[[j]]+{1,1}]},{j,1,
              Length[cd2]}]];
      l=Length[listacd];
      casihue=Map[Prepinta, listacd];
      casipintado=
        Flatten[Table[Map[Prepend[#,(i/l)]&,casihue[[i]]],{i,1,l}],1];
      le=Length[casipintado];
      yacasipintado=
        Table[{Hue[casipintado[[k]][[1]],casipintado[[k]][[2]],1],
            casipintado[[k]][[3]]},{k,1,le}];
      Show[Graphics[yacasipintado]]]
  
  
  Pinta3D[cd_]:=
      Module[{ccolor,tcubos},
        TablaCubos3D[colores_List]:=
          Table[{Hue[1,colores[[i]][[2]],1],
              Cuboid[colores[[i]][[1]],colores[[i]][[1]]+{1,1,1}]},{i,
              1,(Length[colores])}];
        ccolor=CocicloColor[cd];
        tcubos=TablaCubos3D[ccolor];
        Show[Graphics3D[tcubos],Lighting\[Rule]False]];
  
  PintaDensidad2D[cd_]:=Module[{Md},
        cd2=Table[cd[[i]][[2]],{i,1,(Length[cd])}];
        Md=Max[cd2];
        Show[
          Graphics3D[
            Map[Cuboid[Append[First[#],0],Append[First[#]+{1,1},Last[#]/Md]]&,
              cd],ViewPoint\[Rule]{-2,-2,2}]]];
  
  etiquetas[eti_]:=
      Module[{lista},
        opera[lista_,i_]:=If[lista[[i]]==0,{},{ReplacePart[lista,0,i]}];
        pera[lista_]:=Flatten[Table[opera[lista,i],{i,1,Length[lista]}],1];
        pera[eti]];
  
  bajadimen[uno_]:=Module[{etas,a,b},etas=etiquetas[Last[uno]];
        a=Table[{First[uno],etas[[j]]},{j,1,Length[etas]}];
        b=
          Table[{First[uno]+Last[uno]-etas[[j]],etas[[j]]},{j,1,
              Length[etas]}];
        Union[a,b]];
  
  bajadimension[cubos_]:=Union[Flatten[Map[bajadimen,cubos],1]];
  
  etiquetassigno[eti_]:=Module[{lista},suma[x_,i_]:=Sum[x[[j]],{j,1,i}];
        opera[lista_,i_]:=
          If[lista[[i]]==0,{},{{ReplacePart[lista,0,i],(-1)^suma[eti,i]}}];
        pera[lista_]:=Flatten[Table[opera[lista,i],{i,1,Length[lista]}],1];
        pera[eti]];
  
  borde[datolargo_]:=
      Module[{etassigno,as,bs},etassigno=etiquetassigno[Last[datolargo]];
        as=
          Table[{First[datolargo],First[etassigno[[j]]],
              Last[etassigno[[j]]]},{j,1,Length[etassigno]}];
        bs=
          Table[{First[datolargo]+Last[datolargo]-First[etassigno[[j]]],
              First[etassigno[[j]]],-Last[etassigno[[j]]]},{j,1,
              Length[etassigno]}];
        Union[as,bs]];
  
  coefuno[borde_]:=Map[{#[[1]],#[[2]]}&,Select[borde,#[[3]]==1&]];
  
  coefmenosuno[borde_]:=Map[{#[[1]],#[[2]]}&,Select[borde,#[[3]]==-1&]];
  
  CuboIncidencia[{listadecubos_,listaincidencias_}]:=
      Module[{ultimolistadecubos,ultimoscubos,nuevoscubos,matriz,n,m,
          nuevamatriz,d},ultimolistadecubos=Last[listadecubos];
        d=Dimensions[ultimolistadecubos][[2]]-1;
        larga[cor_]:=Map[{Delete[#,-1],IntegerDigits[Last[#],2,d]}&,cor];
        ultimoscubos=larga[ultimolistadecubos];
        m=Length[ultimoscubos];
        nuevoscubos=bajadimension[ultimoscubos];
        n=Length[nuevoscubos];
        lugar[ele_]:=Position[nuevoscubos,ele];
        matriz=Table[0,{i,m},{j,n}];
        nuevamatriz=
          Table[ReplacePart[
              ReplacePart[matriz[[i]],1,
                Flatten[Map[lugar,coefuno[borde[ultimoscubos[[i]]]]],1]],-1,
              Flatten[Map[lugar,coefmenosuno[borde[ultimoscubos[[i]]]]],
                1]],{i,1,m}];
        corta[lar_]:=Map[Append[First[#],FromDigits[Last[#],2]]&,lar];
        resultado={Append[listadecubos,corta[nuevoscubos]],
            Append[listaincidencias,Transpose[nuevamatriz]]}];
  
  PrimeraIncidencia[complejocubico_]:=
      Module[{d,ci},d=Dimensions[complejocubico][[2]];
        ncubo[datos_]:=Map[Append[#,2^d-1]&,datos];
        ci={{ncubo[complejocubico]},{}};
        CuboIncidencia[ci]];
  
  CubosIncidencias[complejocubico_]:=
      Module[{d,ci},d=Dimensions[complejocubico][[2]];
        ncubo[datos_]:=Map[Append[#,2^d-1]&,datos];
        ci={{ncubo[complejocubico]},{}};
        FixedPoint[CuboIncidencia,ci,d]];
  
  
  PseudoComponentes[ccubico_]:=
      Module[{ci,main,cu,nocu,indi,ca,noca,remain,nofilremain,vertical0,saco,
          indi2,inter,a,l,compo,final,ajuste},pi=PrimeraIncidencia[ccubico];
        main=pi[[2]][[1]];
        cu=pi[[1]][[1]];
        nocu=Length[cu];
        indi=Table[i,{i,nocu}];
        ca=pi[[1]][[2]];
        noca=Length[ca];
        ajuste=
          Complement[
            Table[If[Sum[main[[i]][[j]],{j,nocu}]==0,main[[i]]],{i,
                noca}],{Null}];
        remain=If[ajuste!={},ajuste,{Table[0,{i,nocu}]}];
        nofilremain=Length[Transpose[remain][[1]]];
        vertical0=Table[0,{i,nofilremain}];
        saco=
          Complement[
            Table[If[Transpose[remain][[i]]==vertical0,{i}],{i,
                nocu}],{Null}];
        indi2=Complement[indi,Flatten[saco]];
        inter=
          Table[If[remain[[i]][[indi2[[j]]]]!=0,indi2[[j]]],{i,
              nofilremain},{j,Length[indi2]}];
        a=Table[Complement[inter[[i]],{Null}],{i,Length[inter]}];
        l=Length[a];
        Table[
          If[a[[i]]\[Intersection]a[[j]]!={},
            a[[i]]=a[[j]]=Union[a[[i]],a[[j]]],{a[[i]],a[[j]]}={a[[i]],
                a[[j]]}],{i,l},{j,1,l}];
        compo=Union[saco,a];
        final=
          Table[Delete[cu[[compo[[i]][[j]]]],
              Length[cu[[compo[[i]][[j]]]]]],{i,Length[compo]},{j,
              Length[compo[[i]]]}];
        resultado=
          If[ajuste!={},final,
            Table[{Delete[cu[[i]],Length[cu[[1]]]]},{i,nocu}]];
        resultado];
  
  ListaDual[pseudo_]:=
      Module[{dimps,pi,cubos,nocubos,caras,nocaras,main,cubosextendidos,
          bordea,carasdelborde,bi,todoelborde,ce,complejoextendido,sinborde},
        alarga[n_,m_]:=IntegerDigits[n,2,m];
        encoge[eti_List]:=FromDigits[eti,2];dimps=Length[pseudo[[1]]];
        pi=PrimeraIncidencia[pseudo];
        cubos=pi[[1]][[1]];
        nocubos=Length[cubos];
        caras=pi[[1]][[2]];
        nocaras=Length[caras];
        main=pi[[2]][[1]];
        cubosextendidos=
          
          Table[{Delete[cubos[[i]],dimps+1],
              alarga[cubos[[i]][[dimps+1]],dimps]},{i,nocubos}];
        bordea={};
        Table[
          If[Sum[main[[i]][[j]],{j,nocubos}]!=0,
            bordea=Append[bordea,caras[[i]]],bordea=bordea],{i,nocaras}];
        carasdelborde=
          Table[{Delete[bordea[[i]],dimps+1],
              alarga[bordea[[i]][[dimps+1]],dimps]},{i,Length[bordea]}];
        bi=Table[{},{i,dimps}];
        bi[[1]]=carasdelborde;
        Table[bi[[i+1]]=bajadimension[bi[[i]]],{i,dimps-1}];
        todoelborde=Flatten[bi,1];
        ce=Table[{},{i,dimps+1}];
        ce[[1]]=cubosextendidos;
        Table[ce[[i+1]]=bajadimension[ce[[i]]],{i,dimps}];
        complejoextendido=Flatten[ce,1];
        sinborde=Complement[complejoextendido,todoelborde];
        Table[{Table[
              sinborde[[i]][[1]][[j]]+(-1)^(sinborde[[i]][[2]][[j]]+1)1/2,{j,
                dimps}],Table[1-sinborde[[i]][[2]][[j]],{j,dimps}]},{i,
            Length[sinborde]}]
        ];
  
  
  
  DimDual[pseudo_]:=Module[{dp,du,etipseudo},dp=Length[pseudo[[1]]];
        ld=ListaDual[pseudo];
        etipseudo=Table[ld[[i]][[2]],{i,Length[ld]}];
        Max[Table[Sum[etipseudo[[i]][[j]],{j,dp}],{i,Length[ld]}]]];
  
  Dual[pseudo_]:=Module[{du,dimps,orden},
        ld=ListaDual[pseudo];
        ddu=DimDual[pseudo];
        dimps=Length[pseudo[[1]]];
        orden=Table[{},{i,dimps+1}];
        Table[
          If[Sum[ld[[i]][[2]][[j]],{j,dimps}]==k-1,
            orden[[dimps+2-k]]=Append[orden[[dimps+2-k]],ld[[i]]]],{i,
            Length[ld]},{k,dimps+1}];
        orden];
  
  CubosInDual[pseudo_]:=
      Module[{dimps,ddp,dimnuevoscubos,do,lcm,ci},dimps=Length[pseudo[[1]]];
        ddp=DimDual[pseudo];
        dimnuevoscubos=ddp;
        du=Table[Dual[pseudo][[i+dimps-ddp]],{i,ddp+1}];
        lcm=Table[du[[1]][[i]],{i,Length[du[[1]]]}];
        ci={{Table[
                Append[lcm[[i]][[1]],encoge[lcm[[i]][[2]]]],{i,
                  Length[lcm]}]},{}};
        CuboInDual[{listadecubos_,listaincidencias_}]:=
          Module[{ultimolistadecubos,ultimoscubos,nuevoscubos,mduatriz,n,m,
              nuevamatriz,d},ultimolistadecubos=Last[listadecubos];
            
            larga[cor_]:=
              Map[{Delete[#,-1],IntegerDigits[Last[#],2,dimps]}&,cor];
            ultimoscubos=larga[ultimolistadecubos];
            m=Length[ultimoscubos];
            dimnuevoscubos=dimnuevoscubos-1;
            nuevoscubos=du[[ddp-dimnuevoscubos+1]];
            n=Length[nuevoscubos];
            lugar[ele_]:=Position[nuevoscubos,ele];
            matriz=Table[0,{i,m},{j,n}];
            
            nuevamatriz=
              Table[ReplacePart[
                  ReplacePart[matriz[[i]],1,
                    Flatten[Map[lugar,coefuno[borde[ultimoscubos[[i]]]]],
                      1]],-1,
                  Flatten[Map[lugar,coefmenosuno[borde[ultimoscubos[[i]]]]],
                    1]],{i,1,m}];
            corta[lar_]:=Map[Append[First[#],FromDigits[Last[#],2]]&,lar];
            
            resultado={Append[listadecubos,corta[nuevoscubos]],
                Append[listaincidencias,Transpose[nuevamatriz]]}];
        FixedPoint[CuboInDual,ci,ddp]];
  
  PintaDual2D[pseudo_]:=
      Module[{dp,du,ddp,cuadros,vercuadros,segmentos,versegmentos,puntos,
          verpuntos},dp=Length[pseudo[[1]]];
        cuadradito[punto_]:=Rectangle[punto,punto+{1,1}];
        du=Dual[pseudo];
        ddp=DimDual[pseudo];
        cuadros=du[[1]];
        vercuadros=Table[cuadros[[i]][[1]],{i,Length[cuadros]}];
        segmentos=du[[2]];
        versegmentos=
          Table[{segmentos[[i]][[1]],
              segmentos[[i]][[1]]+segmentos[[i]][[2]]},{i,
              Length[segmentos]}];
        puntos=du[[3]];
        verpuntos=Table[puntos[[i]][[1]],{i,Length[puntos]}];
        Show[
          Graphics[{Map[cuadradito,vercuadros],Map[Line,versegmentos],
              Map[Point,verpuntos]}]]];
  
  esquinas[cuadro_]:=Module[{et},et=etiquetas[cuadro[[2]]];
        {cuadro[[1]],cuadro[[1]]+et[[1]],cuadro[[1]]+cuadro[[2]],
          cuadro[[1]]+et[[2]]}];
  
  PintaDual3D[pseudo_]:=
      Module[{dp,du,ddp,cubos,vercubos,cuadros,vercuadros,segmentos,
          versegmentos,puntos,verpuntos},dp=dim[pseudo];
        du=Dual[pseudo];
        ddp=DimDual[pseudo];
        cubos=du[[1]];
        vercubos=Table[cubos[[i]][[1]],{i,Length[cubos]}];
        cuadros=du[[2]];
        vercuadros=Map[esquinas,cuadros];
        segmentos=du[[3]];
        versegmentos=
          Table[{segmentos[[i]][[1]],
              segmentos[[i]][[1]]+segmentos[[i]][[2]]},{i,
              Length[segmentos]}];
        puntos=du[[4]];
        verpuntos=Table[puntos[[i]][[1]],{i,Length[puntos]}];
        Show[
          Graphics3D[{Map[Cuboid,vercubos],Map[Polygon,vercuadros],
              Map[Line,versegmentos],Map[Point,verpuntos]}]]];
  
  Homologia[ci_]:=
      Module[{infac,numerocubos,infacnonulos,dimensionciclos,dimensionbordes,
          betti,torsion},
        infac=Map[InvariantFactors,Last[ci]];
        numerocubos=Map[Length,First[ci]];
        quitaceros[lista_]:=Select[lista,#=!=0&];
        infacnonulos=Map[quitaceros,infac];
        dimensionciclos=numerocubos-Append[Map[Length,infacnonulos],0];
        dimensionbordes=Prepend[Map[Length,infacnonulos],0];
        betti=dimensionciclos-dimensionbordes;
        buscator[lista_]:=Select[lista,And[#=!=1,#=!=-1]&];
        torsion=Map[buscator,infacnonulos];
        {betti,torsion}];
  
  SetAttributes[{LeftFactors, RightFactors}, {HoldAll}]
  
  MakeFactorList[A_] := Factors[LeftFactors[], A, RightFactors[]]
  
  
  (*Matrix Operations*)
  
  
  FindMinPosition[A_?MatrixQ] := 
    	Module[{B, min},
      		B = $Delta[ A ];
      		min = Min[ Flatten[B]  ];
      		Position[ B, min, 2, 1]]
  		
  SubMatrix[A_?MatrixQ, n_Integer] := Map[Drop[#, n-1]&, Drop[A, n-1]]
  
  FindMinPosition[A_?MatrixQ, n_Integer] := 
    	FindMinPosition[ SubMatrix[A, n] ] + (n-1)
  
  SwitchRows[{i_, i_}, fac_Factors] := fac
  
  SwitchColumns[{i_, i_}, fac_Factors] := fac
  
  SwitchRows[{i_, j_}, A_?MatrixQ] := 
    	A[[  Range[ Dimensions[A][[1]] ]  /. {i -> j, j -> i}  ]]
  
  SwitchRows[{i_, j_}, Factors[llist_, A_, rlist_]] :=
    	Module[{m},
      	m = Dimensions[A][[1]];
      	Factors[Append[llist,PermutationMatrix[i,j,m]],SwitchRows[{i,j}, A], 
        rlist] ]
  
  SwitchColumns[{i_, i_}, A_?MatrixQ] := A
  
  SwitchColumns[{i_, j_}, A_?MatrixQ] := 
    	Transpose[ SwitchRows[{i, j}, Transpose[A] ] ]
  
  SwitchColumns[{i_, j_}, Factors[llist_, A_, rlist_]] :=
    	Module[{n},
      	n = Dimensions[A][[2]];
      	 Factors[llist, SwitchColumns[{i, j}, A], 
        Prepend[rlist, PermutationMatrix[i,j,n]] ] ]
  
  Reposition[fac:Factors[llist_, A_, rlist_], n_Integer] := 
    	Module[{i, j},
      		{{i, j}} = FindMinPosition[A, n];
      		SwitchRows[ {n, i},  SwitchColumns[ {n, j},  fac] ] ]
  
  RowOperations[fac:Factors[llist_, A_, rlist_], n_Integer] := 
    	Module[{ann = A[[n, n]], B = A, m, an, i, q, nllist = llist},
      	      If[ann === 0, fac,
        		m = Dimensions[A][[1]];
        		For[i=n+1; an = A[[n]], i<=m, i++,
          		      If[(q = $Quotient[ A[[i,n]], ann]) =!= 0, 
            			  AppendTo[nllist, ElementaryMatrix[i, n, q, m]]; 
            			  		   B[[i]] = Chop[Simplify[B[[i]] - q*an]]]];
        		Factors[nllist,    B,    rlist] ] ]
  
  ColumnOperations[fac:Factors[llist_, A_, rlist_], n_Integer] := 
    	Module[{ann = A[[n, n]], B = Transpose[A], m, an, i, q, nrlist = rlist},
      	      If[ann === 0, fac,
        		m = Dimensions[A][[2]];
        		For[i=n+1; an = B[[n]], i<=m, i++,
          		      If[(q = $Quotient[B[[i,n]], ann]) =!= 0, 
            			  PrependTo[nrlist, ElementaryMatrix[n, i, q, m]]; 
            			  		    B[[i]] = Chop[Simplify[B[[i]] - q*an]]]];
        		Factors[llist,    Transpose[B],    nrlist] ] ]
  
  RCOperations[fac_Factors, n_Integer] := 
    	ColumnOperations[ RowOperations[ Reposition[fac, n], n], n]
  
  
  OneStep[fac_Factors, n_Integer] := FixedPoint[RCOperations[#, n]&, fac]
  
  DivisibleQ[A_?MatrixQ] := 
    	Module[{a}, 
      		If[ (a = Simplify[A[[1,1]]]) =!= 0, 
        		Union[ $Mod[ Flatten[A], a ]]  === {0}, 
        		True] ]
  
  AddRow[{i_, j_}, Factors[llist_, A_, rlist_]] := 
         Module[{m},
      	m = Dimensions[A][[1]];
      	Factors[Append[llist, ElementaryMatrix[i, j, -1, m]], 
        			ReplacePart[A, A[[i]]+A[[j]], i], rlist]]
  
  DivisibilityReposition[fac:Factors[llist_, A_, rlist_], n_] := 
    	Module[{B, i, u}, 
      		B = SubMatrix[A, n];
      		If[ DivisibleQ[B], 
        			fac, 
        			{u} = Select[ Flatten[B], $Mod[#, B[[1,1]] ] =!= 0&, 1];
        			i = Position[ B, u, 2, 1][[1,1]];
        			AddRow[{n, n+i-1}, fac] ]]
  
  DivisibleOneStep[fac_Factors, n_] := 
      FixedPoint[DivisibilityReposition[OneStep[#1, n], n] &, fac]
  
  Diagonalize[(A_)?MatrixQ] := 
      Fold[DivisibleOneStep, MakeFactorList[A], Range[Min[Dimensions[A]]]]
  
  
  
  (*User Interface*)
  
  GaussianIntegerQ[z_] := MatchQ[z, Complex[_Integer, _Integer] | _Integer];
  
  ElementaryDecomposition[matrix_?MatrixQ, opts___Rule] := 
    	Module[{ans},
      	    Which[
        		MatrixQ[matrix, IntegerQ],
        			$Delta = Function[n, If[n=!=0, Abs[n], Infinity], {Listable}]; 
        			$Quotient = Function[{n, m}, Quotient[n,m]];
        			$Mod = Function[{n, m}, Mod[n,m], {Listable}];,
        		MatrixQ[matrix, GaussianIntegerQ],
        			$Delta = Function[n, If[n=!=0, Abs[n]^2, Infinity], {Listable}];
        			$Quotient = Function[{n, m}, Round[n / m]];
        			$Mod = Function[{n, m}, n - Round[n / m] * m, {Listable}];,
        		True,
        			Message[ElementaryDecomposition::notint]; Abort[]];
      	     ans = Diagonalize[matrix]; 
      	     ans = Apply[List, MapAt[List, ans, 2], {0, 1}];
      	     padded = Padded /. {opts} /. Options[ElementaryDecomposition];
      	     If[padded === False, ans, Pad[ans]]]
  	     
  
  ElementaryDecomposition[matrix_?MatrixQ, t_, opts___Rule] := 
    	Module[{ans},
      	    
      If[Not[MatrixQ[matrix, PolynomialQ[#, t]&]], 
        Message[ElementaryDecomposition::notpoly]; Abort[]];
      	    $Delta = 
        Function[p, If[p=!=0, Exponent[p, t], Infinity], {Listable}];
      	    $Quotient = Function[{p, q}, PolynomialQuotient[p, q, t]];
      	    $Mod = Function[{p,q}, PolynomialRemainder[p, q, t], {Listable}];
      	     ans = Diagonalize[matrix]; 
      	     ans = Apply[List, MapAt[List, ans, 2], {0, 1}];
      	     padded = Padded /. {opts} /. Options[ElementaryDecomposition];
      	     If[padded === False, ans, Pad[ans]]]
  
  	     
  NormalDecomposition[matrix_?MatrixQ] := 
    	Module[{factors},
      		factors = ElementaryDecomposition[matrix, Padded -> True];
      		{ Dot @@ factors[[1]], factors[[2, 1]], Dot @@ factors[[3]] } ]
  		
  NormalDecomposition[matrix_?MatrixQ, t_] := 
    	Module[{factors},
      		factors = ElementaryDecomposition[matrix, t, Padded -> True];
      		{ Dot @@ factors[[1]], factors[[2, 1]], Dot @@ factors[[3]] } ]
  
  
  InvariantFactors[matrix_?MatrixQ] :=
    	Module[{mat},
      		mat = ElementaryDecomposition[matrix][[2, 1]];
      		Table[mat[[i,i]], {i, 1, Min[Dimensions[matrix]]}]]
  
  InvariantFactors[matrix_?MatrixQ, t_] :=
    	Module[{mat},
      		mat = ElementaryDecomposition[matrix, t][[2, 1]];
      		Table[mat[[i,i]], {i, 1, Min[Dimensions[matrix]]}]]
  
  
  
  
  (*Elementary Matrix Padding*)
  
  SetAttributes[Pad, {Listable}];
  
  Pad[PermutationMatrix[i_, j_, n_]] := 
    	IdentityMatrix[n][[ Range[n] /. {i -> j, j -> i} ]]
  
  Pad[ElementaryMatrix[i_, j_, a_, n_]] := 
    	ReplacePart[IdentityMatrix[n], a, {i, j}]
  
  Pad[n_] := n
  	
  
  (*Testing*)
  
  CheckIt[factors_] :=  
    	With[{fac = Pad[factors]}, 
      		(Dot @@ fac[[1]]) . fac[[2,1]] . (Dot @@ fac[[3]])]
  
  
  
  
  (*Formats*)
  
  
  Format[PermutationMatrix[i_,j_,n_]] := Subscripted["p"[i,j]]
  
  Format[ElementaryMatrix[i_,j_,a_, n_]] := Subscripted["e"[i, j, a], {1, 2}]
  
  
  
  HoComCaComCu[datos_,size_]:=Module[{cc,ci},
        cc=ComplejoCubico[datos,size];
        ci=CubosIncidencias[cc];
        Homologia[ci]
        ];
  
  HoComCaDualComCu[datos_,size_]:=Module[{cc,cid},
        cc=ComplejoCubico[datos,size];
        cid=CubosInDual[cc];
        Homologia[cid]
        ];
  
  HoComCaDualPseudoComCu[datos_,size_]:=Module[{cc,pscc,cidps},
        cc=ComplejoCubico[datos,size];
        pscc=PseudoComponentes[cc];
        cidps=Map[CubosInDual,pscc];
        Map[Homologia,cidps]
        ];
  
  HoComCaDualPseudoComCu2D[datos_,size_]:=Module[{cc,cd,pscc,pscd,cidps},
        cc=ComplejoCubico[datos,size];
        cd=CocicloDensidad[datos,size];
        pscd=CDPseudoComponentes[cd];
        pscc=PseudoComponentes[cc];
        cidps=Map[CubosInDual,pscc];
        Print["Las pseudocomponentes coloreadas son"];
        Print[PintaPseudo2D[pscd]];
        Print[
          "La homolog\[IAcute]a de los duales de las psuedocomponentes viene \
dada por"];
        Map[Homologia,cidps]] ;
  
  
  
  
  
  End[]
  
  Protect[ElementaryDecomposition, NormalDecomposition, InvariantFactors]
  
  
  EndPackage[]